-- $Name:Weapon of Li Guan$
-- $Name(ru):Оружие Ли Гуана$
-- $Version:0.0.1$
instead_version '1.9.0'
require 'para'
require 'nolife'
--require 'dbg'

stead.scene_delim = '^' -- одинарный перевод строки

-- game.gui.hideways = true; -- для скрытия ways

dofile ('parser/metaparser.lua');
input.cursor = img 'images/cursor.gif';
morph.debug = true;
parser.cmd_history = true;
parser.empty_warning = '?';
parser.hintinv = true;
morph.yo = true;
morph:init ('main.lua', 'rooms.lua', 'items.lua', 'npc.lua');
me().person = 2;
me().plural = true;

parser.err_filter = false;

game.verbs = {};
parser.verb.Close();
parser.verb.Drop();
parser.verb.Exam();
parser.verb.Give();
parser.verb.Inventory();
parser.verb.Pull();
parser.verb.Put();
parser.verb.Read();
parser.verb.Search();
parser.verb.Take();
parser.verb.Wait();
parser.verb.Walk();
--parser.verb.Tie();

--parser.hideverbs = true; -- если прятать глаголы


dofile ('globals.lua');
dofile ('rooms.lua');
dofile ('items.lua');
dofile ('npc.lua');
dofile ('verbs.lua');

--game.codepage="UTF-8"

me().Exam = function (s)
    if not ScoreEffect then
        p [[Вас зовут Ди Жэньчжи, вы прожили уже три круга (двенадцатилетия) и
        являетесь профессиональным государственным чиновником – начальником
        уезда. Вы одеты в простую дорожную одежду. По ней Вас можно принять за
        странствующего каллиграфа, торговца книгами или образованного
        паломника.
        ]];
    else
        p [[Вас зовут Ди Женьчжи, и Вы – судья, начальник уезда. Но в это
        поверит сейчас не каждый – у Вас большая шишка на голове, растрёпанные
        волосы, разорванная одежда.
        ]];
    end
    return;
end


main = room
{
    nam = '«Оружие Ли Гуана»',
    -- картина Сэссю (雪舟, 1420-1506) «Зима»
    gfx = 'images/title.png',
    enter = function (s)
        set_music ('music/yin_and_yang.ogg');
    end,
    dsc = function (s)
        p [[Версия 0.0.1 (03.10.2013)^
        Copyright (c) 2007 Идея, сюжет и текст: Евгений Туголуков (Korwin),^
        Игра создана на конкурс мини-игр «ChiCo 2007».^
        Адаптация для INSTEAD: Вадим В. Балашов (v.v.b.)^
        ]];
        return;
    end,
    About = code [[ walk 'about' ]],
    Next = code [[ walk 'intro' ]],
    Help = code [[ walk 'help' ]],
    Gratitudes = code [[ walk 'gratitudes' ]],
    Settings = code [[ walk 'settings' ]],
    verbs =
    {
        { 'About', 'автор' };
        { 'Help', 'помощь' };
        { 'Gratitudes', 'благодарности' };
        { 'Settings', 'настройки' };
        { 'Next', 'начать игру' };
    };
};


about = room
{
    nam = 'Автор',
    nolife = true,
    dsc = function (s)
        p [[В этой игре описывается одно из дел знаменитого судьи Ди, жившего
        в эпоху правления славной династии Тан, в первой половине VII столетия
        нашей эры. Этот судья был уроженцем города Тайюань, столицы провинции
        Шаньси. Его фамилия была Ди, имя Жэньчжи, а литературный псевдоним
        Хуайюн. Его выдающиеся дела в свое время вошли в официальную «Историю
        династии Тан», и поэтому эти материалы легко доступны всем
        интересующимся.^
        Однако некоторые факты, относящиеся к началу карьеры Ди Жэньчжи,
        который в то время уже был известным судьей, в официальных записях или
        были опущены, или излагались очень сжато.^
        Их надо искать по разрозненным историческим трудам, в местных архивах
        городов, где он служил судьёй, и тому подобных источниках.^
        И всё же эти менее известные факты представляют немалый интерес.
        Они заставляют нас восхищаться этим человеком.^
        Эти факты показывают, что Ди Жэньчжн не только верно служил Трону,
        но был также мудрым судьёй, великим гражданином, сочетавшим
        необыкновенную проницательность с доброжелательностью и уважением к
        справедливости. В этой истории Вы узнаете об одном раннем, и потому
        малоизвестном широкой публике деле знаменитого судьи Ди Жэньчжи под
        названием «Дело об оружии Ли Гуана».^^
        Автор – Туголуков Евгений Витальевич.^
        В Интернете – Korwin.^
        Широко известен в узких кругах российских любителей адвентюр.^
        Связь – tightbow [at] yandex.ru^^
        В заставке использован фрагмент картины Сэссю (1420-1506) «Зима».^
        Музыка: Oliver Shanti – «The Yin And Yang In Harmony» с альбома 1997
        года «Buddha and Bonsai Vol. 2».
        ]];
    end,
    Back = code [[ back() ]],
    verbs =
    {
        { 'Back', 'назад' },
    },
};


help = room
{
    nam = 'Помощь',
    nolife = true,
    dsc = function (s)
        p [[Как играть в текстовые приключения?^
        Попробуйте представить себя на месте главного героя и пишите те
        команды, которые он должен выполнить.^
        Всё разумное программа поймёт, а если у неё это не получится, то она
        сообщит почему.^
        Команды нужно указывать глаголом неопределённой формы или
        повелительного наклонения, к которому можно добавить основной и
        вспомогательный объект. Например:^
        идти^
        есть^
        заглянуть в дверь^
        отпереть дверь ключом^
        открыть дверь^
        ВНИМАНИЕ! в игре глаголы ОТКРЫТЬ и ОТПЕРЕТЬ выполняют разные действия!
        взять палку^
        попросить слугу : возьми палку^
        написать приказ на бумаге^
        счёт – выводит текущий счёт игры.^
        карта – выводит карту локаций. Обновляется по мере прохождения.^
        Начните вводить слово, внизу появятся предлагаемые варианты. Дополнение
        работает по нажатию клавиши «TAB» или «пробел».^^
        Эта игра была написана на конкурс ChiCo 2007. Условием конкурса
        являлось прохождение игры за 20 ходов. Поэтому, чтобы с одной стороны,
        не лишать игрока возможности полностью окунуться в атмосферу
        средневекового Китая времён династии Тан, а с другой, не нарушить
        правила конкурса, в игре есть возможность переключить режимы игры
        («мини» и «макси»). В «мини»-варианте путь к победе короче, но и
        возможностей проявить свой интеллект куда меньше, и Ваш ранг по
        команде «счёт» вряд ли превысит уровень кандидата. «Макси»-вариант это
        полная игра со всеми её «вкусностями»!
        Сейчас включён вариант игры
        ]];
        if (MaxWeapon > 2) then
            p '«МАКCИ».';
        else
            p '«МИНИ».';
        end
        p 'Желаю приятной игры!';
    end,
    Back = code [[ back(); ]],
    verbs =
    {
        { 'Back', 'назад' },
    },
};


gratitudes = room
{
    nam = 'Благодарности',
    nolife = true,
    dsc = function (s)
        p [[Я искренне благодарю всех людей, без которых эта игра не могла бы
        появиться на свет:^
        своих маму и папу, – по понятным причинам;^
        свою жену (она терпела много вечеров мужа, сидящего у компьютера,
        а не занимающегося чем-то полезным по дому, да ещё и давала ценные
        советы!);^
        Валентина Коптельцева, предложившего правила конкурса мини-игр ChiCo
        2007 и взявшего на себя труд по его организации и финансированию, а
        кроме того, написавшего перевод руководства к RTADS, который прояснил
        для меня много тонких моментов;^
        Андрея Гранкина (GrAnd), подавшего саму идею конкурса, совершившего
        перевод системы TADS на русский язык и много раз помогающего автору
        игры в написании кода и исправлении ошибок;^
        Александра Шумова, моего друга, который помог придумать сюжет игры и
        создать личность «похитителя»;^
        Игоря Семенцова (Gremour), который был главным вдохновителем в
        написании игры, сверхценным помощником, и великолепным бета-тестером;^
        и, наконец, Стаса Старкова, который к созданию этой игры не приложил
        усилий, но своим существованием задавал высокий стандарт качества,
        которому мне хотелось бы соответствовать.^
        Огромное спасибо всем вам, друзья. И спасибо Вам, Игрок, читающий эти
        строки.^
        Искренне Ваш – Евгений Туголуков (Korwin).
        ]];
    end,
    Back = code [[ back(); ]],
    verbs =
    {
        { 'Back', 'назад' },
    },
};


settings = room
{
    nam = 'Настройки',
    nolife = true,
    dsc = function (s)
        p [[Эта игра была написана на конкурс ChiCo 2007. Условием конкурса
        являлось прохождение игры за 20 ходов. Поэтому, чтобы с одной стороны,
        не лишать игрока возможности полностью окунуться в атмосферу
        средневекового Китая времён династии Тан, а с другой, не нарушить
        правила конкурса, в игре есть возможность переключить режимы игры
        («мини» и «макси»). В «мини»-варианте путь к победе короче, но и
        возможностей проявить свой интеллект куда меньше, и Ваш ранг по
        команде «счёт» вряд ли превысит уровень кандидата. «Макси»-вариант это
        полная игра со всеми её «вкусностями»!
        Сейчас включён вариант игры
        ]];
        if (MaxWeapon > 2) then
            p '«МАКCИ».';
        else
            p '«МИНИ».';
        end
    end,
    Min = function(s)
        MaxWeapon = 2;
        walk (settings);
        return;
    end,
    Max = function(s)
        MaxWeapon = 5;
        walk (settings);
        return;
    end,
    Back = code [[ walk (main); ]],
    verbs =
    {
        { 'Back', 'назад' },
        { 'Min', 'МИНИ' },
        { 'Max', 'МАКСИ' },
    },
};


intro = cutscene
{
    nam = 'Предисловие',
    dsc =
    {
        [[Неделю назад, в соответствии с имперской традицией каждые три года
        менять место службы чиновников – чтобы не погрязли в местных связях и
        взятках, – судья Ди, уже заработавший славу умного и честного уездного
        начальника, был переведён со своего прежнего места службы в городе
        Ланьфан, в другое, и, передав дела преемнику, незамедлительно
        направился в путь.^
        Ланьфан располагался далеко на северо-западной границе Поднебесной,
        совсем рядом с владениями уйгуров, бывших подданных тюркютского
        каганата. Сорок лет назад каган Селим был разбит имперскими войсками и
        пленён. Но это было давно. Несмотря на славные победы над каганом,
        северные варвары представляли собой постоянную угрозу спокойствию
        империи.
        ]],
        [[Но пока на дорогах было относительно спокойно и четыре возка с
        жёнами, детьми, имуществом судьи Ди и его слуг охраняли всего горстка
        вооружённых бойцов: старый верный Хун Лян, могучий Ма Жун, быстрый,
        как угорь, Чао Тай, и хитрый Тао Гань. Да и сам Ди Женьчжи был ещё
        вполне крепким человеком и уверенно управлялся с длинным мечом или
        алебардой.
        ]],
        [[На третий день пути, под вечер, отряд остановился в небольшой
        деревне, у подножия горы, на отроге которой высилась пагода, – главная
        башня маленького буддийского монастыря. Утром в гостиницу пришёл монах
        и вручил Ди небольшой свиток – послание от настоятеля.^
        В письме настоятель Чи Чжао уважительно просил судью посетить их,
        «чтобы не дать совершиться преступлению против достояния Поднебесной».
        Настоятель умолял приехать тайно, дабы слухи о похищении не
        распространились широко. Узнав, что коням требуется отдых, а старшая
        жена устала от тряски, недомогает, и совсем не прочь хотя бы на пару
        дней остаться в уютной деревне, судья Ди, в сопровождении Чао Тая,
        поднялся к храму.
        ]],
        [[Их встретил высокий монах, завёрнутый в выцветший халат, и
        проводил в келью. Настоятель Чи Чжао поклонился судье, предложил
        присесть, и, после обычных приветствий, и угощения высокогорным чаем,
        стал рассказывать:
        ]],
        [[«Вчера ночью я заснул как обычно, за час до полуночи. Мне
        приснилось, что в келье кто-то есть. Это был крылатый человек с
        головой дракона, в воинском рогатом шлеме. Он был огромного роста и
        как-бы парил над полом. Конечно, это был дух! Он сказал, что из храма
        скоро будет похищено священное оружие Ли Гуана, и что это нельзя
        предотвратить. Я был взволнован, а воин-призрак добавил: «Ди найдёт
        оружие Ли!» и растаял, как дым.^
        Я проснулся и вспомнил, что у нас в храме нет никакого оружия Ли
        Гуана! Правда, в кладовой есть очень старый сундук, ключ от которого,
        кажется, потерян. Может быть, оружие «крылатого генерала» там?^
        Я не знаю никого в монастыре с фамилией Ди, и в нашей деревне этой
        фамилии нет. Но, спросив брата Шу, я узнал, что знаменитый судья Ди
        проезжает как раз через наши края! Я не знаю, что и думать, и нижайше
        прошу Вас принять соответствующие меры! Я приказал брату Шу помогать
        Вам, Ваше превосходительство, и надеюсь, Вы не дадите совершиться
        преступлению!»
        ]],
        [[В сомнениях, как можно взяться за преступление, которое ещё не
        совершено, судья Ди пообещал, тем не менее, сделать всё, что возможно.
        Затем он послал Чао Тая вниз, сообщить Хун Ляну и остальным спутникам,
        что он задержится и, попросив разрешения осмотреть монастырь, вышел из
        кельи Чи Чжао.
        ]],
    },
    walk_to = 'startroom',
};


win = cutscene
{
    nam = 'Победа',
    dsc =
    {
        [[Вы спустились в деревню. Там на площади собралась большая толпа
        крестьян, окруживших «столб наказаний» в центре площади. К столбу был
        привязан Шу. У его ног лежало похищенное оружие «крылатого генерала»
        Ли Гуана. Рядом стояли Чао Тай и Ма Жун с мечами в руках. Рука Ма Жуна
        была перевязана окровавленной повязкой, но держался он бодро. Увидев
        Ди Женьчжи, люди постепенно замолчали и расступились, давая подойти к
        задержанному преступнику.
        ]],
        [[– Что здесь произошло? – спросил судья Ди.^
        – Услышав звук колокола, мы встревожились, и выбежали посмотреть. Этот
        человек очень быстро спускался по тропинке, и нёс большой мешок. Мы
        решили, что он замыслил недоброе и задержали его. При задержании
        оказал сопротивление, но нас было двое.^
        – Понятно. Этот человек попытался украсть оружие Ли Гуана,
        национальное достояние Поднебесной... За это он должен получить
        наказание пятой степени тяжести. «Шу, признаешь ли ты свою вину, или
        тебя следует подвергнуть пытке?» Шу был сокрушён тем, что его затея не
        удалась, но его дух ещё не был сломлен, его глаза сверкнули и он
        громко крикнул:
        ]],
        [[– Наибольшее удовольствие для китайца, – причинять кому-то
        страдания, наивысшая красота, – искалеченная и извращённая природа.
        Самое желанное блюдо, – рыба, неотличимая по вкусу от курицы, самая
        прекрасная женщина, – та, у которой навсегда изувечены ноги, самый
        красивый дом, – тот, что с изогнутой крышей.  Для этого поистине нужен
        такой же изогнутый, искалеченный и извращённый ум. А мы, жители
        степей, скачем к цели прямо, если дружим, – говорим всегда правду,
        если враждуем, – прямо пускаем стрелы. Вот и ты, правитель уезда,
        говоришь правду и ей служишь лжи, предан своей идее и тем предаёшь
        всех вокруг, потому что лживая и кривая идея твоей Империи пустила на
        потеху злу всё то, что было добрым и честным в твоём народе. Да, это я
        украл оружие Ли Гуана, которое Ваш император давно забыл и потерял! Я
        хотел, чтобы лук стрелял, а щит отражал удары, а не пылился в
        кладовой! Даже здесь, у столба, я – свободный, а ты – раб императора!
        Всего лишь раб!
        ]],
        [[Удар Ма Жуна прервал его речь. Заговорил Ди:^
        – Похищенное оружие Ли Гуана будет доставлено в императорский дворец,
        чтобы беречь покой Поднебесной. Похититель будет также доставлен в
        столицу, потому что он является подданным другого государства и
        решение о его судьбе должна вынести высшая судебная инстанция.
        Отведите его в гостиницу и стерегите хорошенько – он умён и опасен!^
        Шу только плюнул на землю. Крестьяне одобрительными криками восславили
        судью Ди и разошлись по домам, потому что была уже ночь, а завтра надо
        было снова идти работать на поля. Над Поднебесной по-прежнему сияло
        звёздами мирное небо.
        ]],
        [[Описывая эти странные и трудные дела,^
        Можно только восхищаться судьёй минувших дней:^
        Бескорыстный и проницательный,^
        Он был человеком исключительной честности,^
        И скромности. Никому на свете не сказал он о том,^
        Что остановил возможную войну и тем спас тысячи жизней.^^
        <b>ПОЗДРАВЛЯЮ!!!^
        Эта история завершена Вами с честью!</b>
        ]];
    },
    walk_to = 'the_end',
};


the_end = cutscene
{
    nam = 'Счёт',
    dsc = function (s)
        parser.events.before_Show_Score (parser);
        if Score < MaxScore then
            p [[^^Вы прошли игру... Хм... Мне кажется, это был не самый лучший
            вариант прохождения.^
            Не расстраивайтесь, ведь это игра. В отличие от жизни, она
            позволяет попробовать другой путь. Попробуйте переиграть.
            ]];
        end
        return;
    end,
};
